diff --git xscreensaver-5.12/driver/lock.c xscreensaver-5.12/driver/lock.c
--- xscreensaver-5.12/driver/lock.c
+++ xscreensaver-5.12/driver/lock.c
@@ -1369,6 +2050,7 @@ destroy_passwd_window (saver_info *si)
       pw->logo_pixels = 0;
       pw->logo_npixels = 0;
     }
+#endif /* ! HAVE_XSCREENSAVER_LOCK */
 
   if (pw->save_under)
     XFreePixmap (si->dpy, pw->save_under);
@@ -1376,9 +2058,12 @@ destroy_passwd_window (saver_info *si)
   if (cmap)
     XInstallColormap (si->dpy, cmap);
 
+#ifndef HAVE_XSCREENSAVER_LOCK
+  /* si->pw_data is globally allocated and never freed when HAVE_XSS_LOCK */
   memset (pw, 0, sizeof(*pw));
   free (pw);
   si->pw_data = 0;
+#endif
 }
 
 
@@ -1391,6 +2076,49 @@ ignore_all_errors_ehandler (Display *dpy, XErrorEvent *error)
   return 0;
 }
 
+#ifdef HAVE_XSCREENSAVER_LOCK
+/* Catch errors from XRestackWindows, since there's an inherent race
+   condition in which other clients can destroy windows between when
+   we get the notification event and when we send the RestackWindows
+   response to it. */
+static Bool
+safe_XRestackWindows(Display *dpy, Window windows[], int nwindows)
+{
+  XErrorHandler old_handler;
+  XSync (dpy, False);
+  error_handler_hit_p = False;
+  old_handler = XSetErrorHandler (ignore_all_errors_ehandler);
+
+  XRestackWindows (dpy, windows, nwindows);
+
+  XSync (dpy, False);
+  XSetErrorHandler (old_handler);
+  XSync (dpy, False);
+
+  return (!error_handler_hit_p);
+}
+
+static Bool
+safe_XSendEvent(Display *dpy, Window w, Bool propagate,
+                long event_mask, XEvent *event_send)
+{
+  Status status;
+  XErrorHandler old_handler;
+  XSync (dpy, False);
+  error_handler_hit_p = False;
+  old_handler = XSetErrorHandler (ignore_all_errors_ehandler);
+
+  status = XSendEvent (dpy, w, propagate, event_mask, event_send);
+
+  XSync (dpy, False);
+  XSetErrorHandler (old_handler);
+  XSync (dpy, False);
+
+  return (!error_handler_hit_p && status);
+}
+
+#endif
+
 
 #ifdef HAVE_XHPDISABLERESET
 /* This function enables and disables the C-Sh-Reset hot-key, which
@@ -1592,6 +2320,17 @@ passwd_animate_timer (XtPointer closure, XtIntervalId *id)
 
   if (!pw) return;
 
+#ifdef HAVE_XSCREENSAVER_LOCK
+  /* We want to make sure dialog is up before we update countdown timer */
+  if (!si->passwd_dialog)
+    {
+      if (si->prefs.verbose_p)
+        fprintf (stderr,
+                 "-->passwd_animate_timer() returning..no dialog yet\n");
+      return;
+    }
+#endif
+
   pw->ratio -= (1.0 / ((double) si->prefs.passwd_timeout / (double) tick));
   if (pw->ratio < 0)
     {
@@ -1611,6 +2350,7 @@ passwd_animate_timer (XtPointer closure, XtIntervalId *id)
   idle_timer ((XtPointer) si, 0);
 }
 
+#ifndef HAVE_XSCREENSAVER_LOCK
 
 static XComposeStatus *compose_status;
 
@@ -1688,11 +2428,13 @@ finished_typing_passwd (saver_info *si, passwd_dialog_data *pw)
       update_passwd_window (si, "", pw->ratio);
     }
 }
+#endif /* !HAVE_XSCREENSAVER_LOCK */
 
 static void
 handle_passwd_key (saver_info *si, XKeyEvent *event)
 {
   passwd_dialog_data *pw = si->pw_data;
+#ifndef HAVE_XSCREENSAVER_LOCK
   int pw_size = sizeof (pw->typed_passwd) - 1;
   char *typed_passwd = pw->typed_passwd;
   char s[2];
@@ -1705,11 +2447,41 @@ handle_passwd_key (saver_info *si, XKeyEvent *event)
   s[1] = 0;
 
   pw->passwd_changed_p = True;
+#endif /* !HAVE_XSCREENSAVER_LOCK */
 
   /* Add 10% to the time remaining every time a key is pressed. */
   pw->ratio += 0.1;
   if (pw->ratio > 1) pw->ratio = 1;
 
+#ifdef HAVE_XSCREENSAVER_LOCK
+  if (si->pw_data->got_windowid)
+    {
+      Bool status;
+
+      if (si->prefs.verbose_p)
+        fprintf (stderr, "event loop..gotwindowid..and keypress event...\n");
+
+      event->window = si->passwd_dialog;
+
+      status = safe_XSendEvent (si->dpy, si->passwd_dialog,
+                                False, KeyPressMask, (XEvent *) event);
+
+      if (si->prefs.verbose_p)
+        {
+          if (status)
+            fprintf (stderr, "sent key...\n");
+          else
+            fprintf (stderr, "error %d sending key...\n", status);
+        }
+      update_passwd_window (si, NULL, pw->ratio);
+    }
+  else
+    {
+      swallow_unlock_typeahead_events (si, (XEvent *) event);
+    }
+
+#else /* !HAVE_XSCREENSAVER_LOCK */
+
   switch (*s)
     {
     case '\010': case '\177':				/* Backspace */
@@ -1779,6 +2551,7 @@ handle_passwd_key (saver_info *si, XKeyEvent *event)
     {
       update_passwd_window (si, "", pw->ratio);
     }
+#endif /* !HAVE_XSCREENSAVER_LOCK */
 }
 
 
@@ -1801,7 +2574,9 @@ passwd_event_loop (saver_info *si)
 
   passwd_animate_timer ((XtPointer) si, 0);
 
-  while (si->unlock_state == ul_read)
+  si->pw_data->got_passwd = FALSE;
+
+  while (si->unlock_state == ul_read && si->pw_data->got_passwd == FALSE)
     {
       XtAppNextEvent (si->app, &event.x_event);
 
@@ -1842,12 +2617,17 @@ passwd_event_loop (saver_info *si)
 
       if (event.x_event.xany.window == si->passwd_dialog && 
           event.x_event.xany.type == Expose)
+#ifdef HAVE_XSCREENSAVER_LOCK
+	XtDispatchEvent (&event.x_event);
+#else
 	draw_passwd_window (si);
+#endif /* !HAVE_XSCREENSAVER_LOCK */
       else if (event.x_event.xany.type == KeyPress)
         {
           handle_passwd_key (si, &event.x_event.xkey);
           si->pw_data->caps_p = (event.x_event.xkey.state & LockMask);
         }
+#ifndef HAVE_XSCREENSAVER_LOCK
       else if (event.x_event.xany.type == ButtonPress || 
                event.x_event.xany.type == ButtonRelease)
 	{
@@ -1856,6 +2636,82 @@ passwd_event_loop (saver_info *si)
 	  if (si->pw_data->login_button_p)
 	    handle_login_button (si, &event.x_event);
 	}
+#endif /* !HAVE_XSCREENSAVER_LOCK */
+
+ /*
+  5077974 P1 "Bug 147583: Screen Lock unlocks because of GOK dwell movement in
+		core pointer mode"
+
+  ScreenLock did not unlock the screen, but WM's XRestackWindow() did.
+  Once WM/metacity fixes the problem, the code can be removed.
+  The problem:
+    repositioning the Wids in the wrong positions when
+    1. the window type is changed from NORMAL to DOCK or vice versa
+    2. the Wid is managed
+    within the X window stack with or without screen-lock in a mixed Wids
+  there are two temp. get-around solutions:
+    1. non-managed GOK or MAG Wid
+    or
+    2. screensaver picks up the WM's restacking task and fixes the prevous
+       restacking problem.
+       the cons: there is a flashing screen when corepointer is touching
+       GOK or MAG and mouse is moved in a fast way
+       when GOK or MAG window type is DOCK only.
+       and it is not a good temp. get-around solution.
+       This is the only choice if WM did not want to fix the problem now
+       and AT group did not want to use non-managed Wids.
+       Now, GOK only supports 2nd USB/mouse/Dwell, corepointer is supposed
+       not to be used, and GOK cannot disable it
+ */
+/*
+     bugid 6769901,6839026: popup windows appearing through xscreensaver
+*/
+      else if (((event.x_event.xany.type == UnmapNotify)
+             || (event.x_event.xany.type == MapNotify)
+             || (event.x_event.xany.type == VisibilityNotify)
+             || (event.x_event.xany.type == ConfigureNotify)
+             || (event.x_event.xany.type == PropertyNotify)
+             || (event.x_event.xany.type == CreateNotify)
+             || (event.x_event.xany.type == ReparentNotify))
+             && (si->passwd_dialog))
+        {
+          /* Find the handle of popup window
+           * Note: we can not get handle of popup window with
+           * event.xany.window, thats why we have switch cases.
+           */
+          Window wPopWin = 0;
+
+          switch(event.x_event.xany.type)
+            {
+            case ConfigureNotify:
+              wPopWin = event.x_event.xconfigure.window;
+              break;
+            case CreateNotify:
+              wPopWin = event.x_event.xcreatewindow.window;
+              break;
+            case VisibilityNotify:
+              wPopWin = event.x_event.xvisibility.window;
+              break;
+            default:
+              break;
+            }
+
+          if (wPopWin)
+            {
+              saver_screen_info *ssi = find_screen_for_window (si, wPopWin);
+
+              /* This if case is for safety, it prevent screensaver stuck in
+               * loop of ConfigureNotify
+               */
+              if ((wPopWin != si->passwd_dialog) && (ssi != NULL) &&
+                  (wPopWin != ssi->screensaver_window) &&
+                  (wPopWin != ssi->stderr_overlay_window))
+                {
+                  restack_my_windows(si, ssi, wPopWin);
+                }
+            }
+        }
+        /* the above new code for restacking under the condition */
       else
 	XtDispatchEvent (&event.x_event);
     }
@@ -1881,8 +2737,13 @@ passwd_event_loop (saver_info *si)
 
   if (msg)
     {
+#ifdef HAVE_XSCREENSAVER_LOCK
+      write_to_child (si, "ul_message", msg);
+      usleep (250000);  /* 1/4 second */
+#else
       si->pw_data->i_beam = 0;
       update_passwd_window (si, msg, 0.0);
+#endif
       XSync (si->dpy, False);
 
       /* Swallow all pending KeyPress/KeyRelease events. */
@@ -1898,6 +2759,10 @@ passwd_event_loop (saver_info *si)
 static void
 handle_typeahead (saver_info *si)
 {
+/* HAVE_XSCREENSAVER_LOCK: typeahead events are flushed to the external
+   dialog program in handle_passwd_input when we get the dialog_win notice
+   that it has created the window */
+#ifndef HAVE_XSCREENSAVER_LOCK
   passwd_dialog_data *pw = si->pw_data;
   int i;
   if (!si->unlock_typeahead)
@@ -1918,6 +2783,7 @@ handle_typeahead (saver_info *si)
 
   free (si->unlock_typeahead);
   si->unlock_typeahead = 0;
+#endif
 }
 
 
@@ -2023,9 +2889,11 @@ gui_auth_conv(int num_msg,
 	  free(prompt_trimmed);
       }
 
+#ifndef HAVE_XSCREENSAVER_LOCK
       compose_status = calloc (1, sizeof (*compose_status));
       if (!compose_status)
 	goto fail;
+#endif
 
       si->unlock_state = ul_read;
 
@@ -2035,7 +2903,14 @@ gui_auth_conv(int num_msg,
       if (si->unlock_state == ul_cancel)
 	goto fail;
 
+#ifdef HAVE_XSCREENSAVER_LOCK
+      if ((si->unlock_state != ul_time) && si->pw_data->passwd_string)
+        responses[i].response = strdup (si->pw_data->passwd_string);
+      else
+        goto fail;
+#else
       responses[i].response = strdup(si->pw_data->typed_passwd);
+#endif
 
       /* Cache the first response to a PROMPT_NOECHO to save prompting for
        * each auth mechanism. */
@@ -2043,8 +2918,10 @@ gui_auth_conv(int num_msg,
 	  auth_msgs[i].type == AUTH_MSGTYPE_PROMPT_NOECHO)
 	si->cached_passwd = strdup(responses[i].response);
 
+#ifndef HAVE_XSCREENSAVER_LOCK
       free (compose_status);
       compose_status = 0;
+#endif
     }
 
   *resp = responses;
@@ -2052,8 +2929,10 @@ gui_auth_conv(int num_msg,
   return (si->unlock_state == ul_finished) ? 0 : -1;
 
 fail:
+#ifndef HAVE_XSCREENSAVER_LOCK
   if (compose_status)
     free (compose_status);
+#endif
 
   if (responses)
     {
@@ -2109,11 +2988,14 @@ auth_finished_cb (saver_info *si)
       if (XPending (si->dpy))
         {
           XNextEvent (si->dpy, &event);
+#ifndef HAVE_XSCREENSAVER_LOCK
           if (event.xany.window == si->passwd_dialog && 
               event.xany.type == Expose)
             draw_passwd_window (si);
-          else if (event.xany.type == ButtonPress || 
-                   event.xany.type == KeyPress)
+          else
+#endif
+            if (event.xany.type == ButtonPress ||
+                event.xany.type == KeyPress)
             break;
           XSync (si->dpy, False);
         }
diff --git xscreensaver-5.12/driver/passwd-pam.c xscreensaver-5.12/driver/passwd-pam.c
--- xscreensaver-5.12/driver/passwd-pam.c
+++ xscreensaver-5.12/driver/passwd-pam.c
@@ -39,10 +39,16 @@
 #ifndef NO_LOCKING  /* whole file */
 
 #include <stdlib.h>
+#include <xscreensaver-intl.h>
+
 #ifdef HAVE_UNISTD_H
 # include <unistd.h>
 #endif
 
+#ifdef __sun
+# include <deflt.h>
+#endif
+
 extern char *blurb(void);
 
 
@@ -58,6 +64,7 @@ extern char *blurb(void);
 
 #include <sys/stat.h>
 
+#include "dialog-data.h"
 #include "auth.h"
 
 extern sigset_t block_sigchld (void);
@@ -82,7 +89,10 @@ extern void unblock_sigchld (void);
 #endif
 
 static int pam_conversation (int nmsgs,
-                             const struct pam_message **msg,
+#ifndef __sun
+                             const
+#endif
+                             struct pam_message **msg,
                              struct pam_response **resp,
                              void *closure);
 
@@ -183,6 +193,11 @@ pam_try_unlock(saver_info *si, Bool verbose_p,
   struct pam_conv pc;
   sigset_t set;
   struct timespec timeout;
+  int pam_auth_status = 0;  /* Specific for pam_authenticate() status*/
+  int acct_rc, setcred_rc, chauth_rc;
+  int pam_flags = 0;
+
+  uid_t euid = geteuid();
 
   pc.conv = &pam_conversation;
   pc.appdata_ptr = (void *) si;
@@ -191,6 +206,23 @@ pam_try_unlock(saver_info *si, Bool verbose_p,
      `closure' argument to pc.conv always comes in as random garbage. */
   suns_pam_implementation_blows = (void *) si;
 
+#ifdef __sun
+  if (verbose_p)
+    fprintf (stderr, "Before uid=%d euid=%d \n\n", getuid(), geteuid());
+
+  if (seteuid (0) != 0)
+    {
+      if (verbose_p)
+        perror("Could not change euid to root, pam may not work!\n");
+    }
+
+  if (verbose_p)
+    {
+      fprintf (stderr, "After seteuid(0) uid=%d euid=%d \n\n",
+               getuid(), geteuid());
+      fprintf (stderr, "PAM is using SERVICE_NAME=\"%s\"\n\n", service);
+    }
+#endif
 
   /* Initialize PAM.
    */
@@ -201,11 +233,35 @@ pam_try_unlock(saver_info *si, Bool verbose_p,
              status, PAM_STRERROR (pamh, status));
   if (status != PAM_SUCCESS) goto DONE;
 
+#ifdef __sun
+  /* Check /etc/default/login to see if we should add
+     PAM_DISALLOW_NULL_AUTHTOK to pam_flags */
+  if (defopen("/etc/default/login") == 0) {
+    char *ptr;
+    int flags = defcntl(DC_GETFLAGS, 0);
+
+    TURNOFF(flags, DC_CASE);
+    (void) defcntl(DC_SETFLAGS, flags);
+    if ((ptr = defread("PASSREQ=")) != NULL &&
+        strcasecmp("YES", ptr) == 0)
+      {
+        pam_flags |= PAM_DISALLOW_NULL_AUTHTOK;
+      }
+
+    (void) defopen((char *)NULL); /* close current file */
+  }
+#endif
+
   /* #### We should set PAM_TTY to the display we're using, but we
      don't have that handy from here.  So set it to :0.0, which is a
      good guess (and has the bonus of counting as a "secure tty" as
      far as PAM is concerned...)
    */
+
+/* From the pam trace and log file, it is found out that the
+   Sun pam modules can drive itself.
+*/
+#ifndef __sun
   {
     char *tty = strdup (":0.0");
     status = pam_set_item (pamh, PAM_TTY, tty);
@@ -214,6 +270,7 @@ pam_try_unlock(saver_info *si, Bool verbose_p,
                blurb(), tty, status, PAM_STRERROR(pamh, status));
     free (tty);
   }
+#endif
 
   /* Try to authenticate as the current user.
      We must turn off our SIGCHLD handler for the duration of the call to
@@ -243,43 +300,101 @@ pam_try_unlock(saver_info *si, Bool verbose_p,
   timeout.tv_sec = 0;
   timeout.tv_nsec = 1;
   set = block_sigchld();
-  status = pam_authenticate (pamh, 0);
+  pam_auth_status = pam_authenticate (pamh, pam_flags);
 # ifdef HAVE_SIGTIMEDWAIT
   sigtimedwait (&set, NULL, &timeout);
   /* #### What is the portable thing to do if we don't have it? */
 # endif /* HAVE_SIGTIMEDWAIT */
   unblock_sigchld();
 
+#ifdef HAVE_XSCREENSAVER_LOCK
+  /* Send status message to unlock dialog */
+  if (pam_auth_status == PAM_SUCCESS)
+    {
+      if (verbose_p)
+        write_to_child (si, "ul_ok", PAM_STRERROR (pamh, pam_auth_status));
+    }
+  else if (si->unlock_state != ul_cancel && si->unlock_state != ul_time)
+    {
+      write_to_child (si, "ul_fail", PAM_STRERROR (pamh, pam_auth_status));
+    }
+  if (verbose_p)
+    sleep (1);
+#endif
+
+  if (verbose_p)
+      fprintf (stderr, "after calling pam_authenticate state is: %s\n",
+               si->unlock_state == ul_success ? "ul_success" : "ul_fail");
+
   if (verbose_p)
     fprintf (stderr, "%s:   pam_authenticate (...) ==> %d (%s)\n",
-             blurb(), status, PAM_STRERROR(pamh, status));
+             blurb(), pam_auth_status, PAM_STRERROR(pamh, pam_auth_status));
 
-  if (status == PAM_SUCCESS)  /* Win! */
+  if (pam_auth_status == PAM_SUCCESS)  /* Win! */
     {
-      int status2;
+      /* perform PAM account validation procedures for login user only */
+      acct_rc   = pam_acct_mgmt(pamh, pam_flags);
 
-      /* We don't actually care if the account modules fail or succeed,
-       * but we need to run them anyway because certain pam modules
-       * depend on side effects of the account modules getting run.
-       */
-      status2 = pam_acct_mgmt (pamh, 0);
+      /******************************************************************
+           ignore other cases for the time being
+           PAM_USER_UNKNOWN, PAM_AUTH_ERR, PAM_ACCT_EXPIRED
+           (password mgn service module)
+           same as pam_setcred(), focus on auth. service module only
+       *****************************************************************/
 
       if (verbose_p)
         fprintf (stderr, "%s:   pam_acct_mgmt (...) ==> %d (%s)\n",
-                 blurb(), status2, PAM_STRERROR(pamh, status2));
+                 blurb(), acct_rc, PAM_STRERROR(pamh, acct_rc));
+
+#ifdef HAVE_XSCREENSAVER_LOCK
+      /* Send status message to unlock dialog ***/
+      if (acct_rc == PAM_SUCCESS)
+        {
+          if (verbose_p)
+            write_to_child (si, "ul_acct_ok", PAM_STRERROR(pamh, acct_rc));
+        }
+      else
+        write_to_child (si, "ul_acct_fail", PAM_STRERROR(pamh, acct_rc));
+      if (verbose_p)
+        sleep (1);
+#endif
 
       /* HPUX for some reason likes to make PAM defines different from
        * everyone else's. */
 #ifdef PAM_AUTHTOKEN_REQD
-      if (status2 == PAM_AUTHTOKEN_REQD)
+      if (acct_rc == PAM_AUTHTOKEN_REQD)
 #else
-      if (status2 == PAM_NEW_AUTHTOK_REQD)
+      if (acct_rc == PAM_NEW_AUTHTOK_REQD)
 #endif
         {
-          status2 = pam_chauthtok (pamh, PAM_CHANGE_EXPIRED_AUTHTOK);
+          for (int i = 0; i < 3; i++)
+            {
+              chauth_rc  = pam_chauthtok (pamh, PAM_CHANGE_EXPIRED_AUTHTOK);
+              if (chauth_rc == PAM_AUTHTOK_ERR ||
+                  chauth_rc  == PAM_TRY_AGAIN )
+                {
+                  i = 0;
+                  si->unlock_state = ul_read;
+                }
+              else break; /* get out of the loop */
+            }
+
           if (verbose_p)
             fprintf (stderr, "%s: pam_chauthtok (...) ==> %d (%s)\n",
-                     blurb(), status2, PAM_STRERROR(pamh, status2));
+                     blurb(), chauth_rc, PAM_STRERROR(pamh, chauth_rc));
+
+          if (chauth_rc != PAM_SUCCESS)
+            {
+              pam_auth_status = chauth_rc;
+              goto DONE;
+            }
+        }
+      else if (acct_rc != PAM_SUCCESS)
+        {
+          pam_auth_status = acct_rc;
+          write_to_child (si, "pw_acct_fail", PAM_STRERROR(pamh, acct_rc));
+          sleep (3);
+          goto DONE;
         }
 
       /* Each time we successfully authenticate, refresh credentials,
@@ -291,24 +406,57 @@ pam_try_unlock(saver_info *si, Bool verbose_p,
          says that the Linux PAM library ignores that one, and only refreshes
          credentials when using PAM_REINITIALIZE_CRED.
        */
-      status2 = pam_setcred (pamh, PAM_REINITIALIZE_CRED);
+      setcred_rc = pam_setcred (pamh, PAM_REINITIALIZE_CRED);
       if (verbose_p)
         fprintf (stderr, "%s:   pam_setcred (...) ==> %d (%s)\n",
-                 blurb(), status2, PAM_STRERROR(pamh, status2));
+                 blurb(), setcred_rc, PAM_STRERROR(pamh, setcred_rc));
+
+#ifdef HAVE_XSCREENSAVER_LOCK
+      /* Send status message to unlock dialog ***/
+      if (setcred_rc == PAM_SUCCESS)
+        {
+          if (verbose_p)
+            write_to_child (si, "ul_setcred_ok", PAM_STRERROR(pamh, setcred_rc));
+        }
+      else
+        write_to_child (si, "ul_setcred_fail", PAM_STRERROR(pamh, setcred_rc));
+      if (verbose_p)
+        sleep (1);
+#endif
     }
 
  DONE:
   if (pamh)
     {
-      int status2 = pam_end (pamh, status);
-      pamh = 0;
+      int status2 = pam_end (pamh, pam_auth_status);
+      pamh = NULL;
       if (verbose_p)
         fprintf (stderr, "%s: pam_end (...) ==> %d (%s)\n",
                  blurb(), status2,
                  (status2 == PAM_SUCCESS ? "Success" : "Failure"));
     }
 
-  if (status == PAM_SUCCESS)
+  if (seteuid (euid) != 0)
+    {
+      if (verbose_p)
+        perror("Error pam could not revert euid to user running as euid root,"
+               " locking may not work now\n");
+    }
+
+  if (verbose_p)
+    fprintf (stderr,
+             "<--end of pam_authenticate() returning ok_to_unblank = %d\n",
+             (int) ((pam_auth_status == PAM_SUCCESS) ? True : False));
+
+  if (si->pw_data->passwd_string)
+    {
+      memset(si->pw_data->passwd_string, 0,
+             strlen(si->pw_data->passwd_string));
+      free (si->pw_data->passwd_string);
+      si->pw_data->passwd_string = NULL;
+    }
+
+  if (pam_auth_status == PAM_SUCCESS)
     si->unlock_state = ul_success;	     /* yay */
   else if (si->unlock_state == ul_cancel ||
            si->unlock_state == ul_time)
@@ -334,6 +482,13 @@ pam_priv_init (int argc, char **argv, Bool verbose_p)
   const char file2[] = "/etc/pam.conf";
   struct stat st;
 
+#ifdef __sun
+  if (! verbose_p)      /* SUN addition: only print warnings in verbose mode */
+    {                   /* since they are rarely useful and mostly just      */
+      return True;      /* cause confusion when users see them.		     */
+    }
+#endif
+
 # ifndef S_ISDIR
 #  define S_ISDIR(mode) (((mode) & S_IFMT) == S_IFDIR)
 # endif
@@ -360,6 +515,8 @@ pam_priv_init (int argc, char **argv, Bool verbose_p)
                 break;
               }
           fclose (f);
+
+#ifndef __sun  /* disable the misleading message */
           if (!ok)
             {
               fprintf (stderr,
@@ -367,9 +524,11 @@ pam_priv_init (int argc, char **argv, Bool verbose_p)
                   "%s: password authentication via PAM is unlikely to work.\n",
                        blurb(), file2, PAM_SERVICE_NAME, blurb());
             }
+#endif
         }
       /* else warn about file2 existing but being unreadable? */
     }
+#ifndef __sun  /* disable the misleading message */
   else
     {
       fprintf (stderr,
@@ -377,15 +536,19 @@ pam_priv_init (int argc, char **argv, Bool verbose_p)
                "%s: password authentication via PAM is unlikely to work.\n",
                blurb(), file2, file, blurb());
     }
+#endif
 
   /* Return true anyway, just in case. */
   return True;
 }
 
 
-static int
+int
 pam_conversation (int nmsgs,
-		  const struct pam_message **msg,
+#ifndef __sun
+                  const
+#endif
+		  struct pam_message **msg,
 		  struct pam_response **resp,
 		  void *vsaver_info)
 {
diff --git xscreensaver-5.12/driver/passwd.c xscreensaver-5.12/driver/passwd.c
--- xscreensaver-5.12/driver/passwd.c
+++ xscreensaver-5.12/driver/passwd.c
@@ -35,6 +35,7 @@
 
 #include <X11/Intrinsic.h>
 
+#include "dialog-data.h"
 #include "xscreensaver.h"
 #include "auth.h"
 
diff --git xscreensaver-5.12/driver/setuid.c xscreensaver-5.12/driver/setuid.c
--- xscreensaver-5.12/driver/setuid.c
+++ xscreensaver-5.12/driver/setuid.c
@@ -145,7 +145,10 @@ set_ids_by_number (uid_t uid, gid_t gid, char **message_ret)
     gid_errno = errno ? errno : -1;
 
   errno = 0;
-  if (setuid (uid) != 0)
+/*mali  if (setuid (uid) != 0)**we need root privs back at pam_authenticate
+  this is causing to loose root priv for good, not good **/
+
+  if (seteuid (uid) != 0)
     uid_errno = errno ? errno : -1;
 
   if (uid_errno == 0 && gid_errno == 0 && sgs_errno == 0)
diff --git xscreensaver-5.12/driver/subprocs.c xscreensaver-5.12/driver/subprocs.c
--- xscreensaver-5.12/driver/subprocs.c
+++ xscreensaver-5.12/driver/subprocs.c
@@ -243,7 +243,11 @@ show_job_list (void)
 
 static void clean_job_list (void);
 
+#ifdef HAVE_XSCREENSAVER_LOCK
+struct screenhack_job *
+#else
 static struct screenhack_job *
+#endif
 make_job (pid_t pid, int screen, const char *cmd)
 {
   struct screenhack_job *job = (struct screenhack_job *) malloc (sizeof(*job));
@@ -407,7 +411,11 @@ unblock_sigchld (void)
   block_sigchld_handler--;
 }
 
+#ifdef HAVE_XSCREENSAVER_LOCK
+int
+#else
 static int
+#endif
 kill_job (saver_info *si, pid_t pid, int signal)
 {
   saver_preferences *p = &si->prefs;
@@ -590,9 +598,14 @@ describe_dead_child (saver_info *si, pid_t kid, int wait_status)
 	 mention them) if we've just killed the subprocess.  But mention them
 	 if they happen on their own.
        */
-      if (!job ||
-	  (exit_status != 0 &&
-	   (p->verbose_p || job->status != job_killed)))
+
+      if ((!job
+#ifdef HAVE_XSCREENSAVER_LOCK
+	   && kid != si->passwd_pid
+#endif /* HAVE_XSCREENSAVER_LOCK */
+	      ) ||
+	   (exit_status != 0 &&
+	    (p->verbose_p || (job && job->status != job_killed))))
         {
           /* Don't call fprintf() from signal handlers, as it might malloc.
 	  fprintf (stderr,
@@ -632,8 +645,12 @@ describe_dead_child (saver_info *si, pid_t kid, int wait_status)
   else if (WIFSIGNALED (wait_status))
     {
       if (p->verbose_p ||
-	  !job ||
-	  job->status != job_killed ||
+	  (!job
+#ifdef HAVE_XSCREENSAVER_LOCK
+	   && kid != si->passwd_pid
+#endif /* HAVE_XSCREENSAVER_LOCK */
+		  ) ||
+	  (job && job->status != job_killed) ||
 	  WTERMSIG (wait_status) != SIGTERM)
         {
           /* Don't call fprintf() from signal handlers, as it might malloc.
@@ -701,12 +718,20 @@ describe_dead_child (saver_info *si, pid_t kid, int wait_status)
   /* Clear out the pid so that screenhack_running_p() knows it's dead.
    */
   if (!job || job->status == job_dead)
+    {
     for (i = 0; i < si->nscreens; i++)
       {
 	saver_screen_info *ssi = &si->screens[i];
 	if (kid == ssi->pid)
 	  ssi->pid = 0;
       }
+#ifdef HAVE_XSCREENSAVER_LOCK
+      if (kid == si->passwd_pid)
+	{
+	  si->passwd_pid = 0;
+	}
+#endif
+    }
 }
 
 #else  /* VMS */
